//őlAŏlŒ`tB^

package imageFiltering.filter;

import imageFiltering.*;
import java.awt.*;
import java.applet.*;
import java.awt.event.*;

public class FilterMaxMin extends Filter 
{
    int windowSize = 7;	//lTEBhETCY
    final int windowSizeMAX = 50;
    final int windowSizeMIN = 1;
    
    //EBhETCYύX΁AɏC̕Kv͂Ȃ
    int centerIndex = windowSize*windowSize / 2;	//̃CfbNX
    //e
	int arrayR[] = new int[windowSize*windowSize];
	int arrayG[] = new int[windowSize*windowSize];
	int arrayB[] = new int[windowSize*windowSize];
	
		
    //̃tB^̖̂Ԃ
    public String getName()
    {
	return "Max-Min";
    }
	
    //摜̃tB^O
    public void filter(AnimatedImage AI)
    {
	
	int centerIndex = windowSize*windowSize / 2;	//̃CfbNX
    //e
	int arrayR[] = new int[windowSize*windowSize];
	int arrayG[] = new int[windowSize*windowSize];
	int arrayB[] = new int[windowSize*windowSize];
	
	
	int preOffset = (windowSize-1) / 2;
	int afterOffset = windowSize - preOffset - 1;
	for (int y=0; y<AI.getHeight(); y++) {
	    for (int x=0; x<AI.getWidth(); x++) {
		int index = 0;
		if ( x-preOffset<0 || x+afterOffset>=AI.getWidth() 
		     || y-preOffset<0 || y+afterOffset>=AI.getHeight() ) {	//ʂ̒[̕
		    for (int ix=-preOffset; ix<=afterOffset; ix++) {
			for (int iy=-preOffset; iy<=afterOffset; iy++) {
			    if ( x+ix<0 || x+ix>=AI.getWidth() || y+iy<0 || y+iy>=AI.getHeight() ) {	
				arrayR[index] = AI.getR( x, y );
				arrayG[index] = AI.getG( x, y );
				arrayB[index] = AI.getB( x, y );
			    } else {
				arrayR[index] = AI.getR( x+ix, y+iy );
				arrayG[index] = AI.getG( x+ix, y+iy );
				arrayB[index] = AI.getB( x+ix, y+iy );
			    }
			    index++;
			}
		    }
		    for ( ; index<windowSize*windowSize; index++) {
			arrayR[index] = AI.getR(x,y);
			arrayG[index] = AI.getG(x,y);
			arrayB[index] = AI.getB(x,y);
		    }
		} else {		//ʂ̒
		    for (int ix=-preOffset; ix<=afterOffset; ix++) {
			for (int iy=-preOffset; iy<=afterOffset; iy++) {
			    arrayR[index] = AI.getR( x+ix, y+iy );
			    arrayG[index] = AI.getG( x+ix, y+iy );
			    arrayB[index] = AI.getB( x+ix, y+iy );
			    index++;
			}
		    }
		}
		this.maxMinSort();
		/*				//ől
						int R = arrayR[arrayR.length-1];
						int G = arrayG[arrayG.length-1];
						int B = arrayB[arrayB.length-1];
		*/				
		/*				//ŏl
						int R = arrayR[0];
						int G = arrayG[0];
						int B = arrayB[0];
		*/				
		/*				//őlƍŏl̍
						int R = arrayR[arrayR.length-1] - arrayR[0];
						int G = arrayG[arrayG.length-1] - arrayG[0];
						int B = arrayB[arrayB.length-1] - arrayB[0];
		*/				
				//őlƍŏl̋߂
		int R = AI.getR(x,y);
		int G = AI.getG(x,y);
		int B = AI.getB(x,y);
		R = (Math.abs(R-arrayR[arrayR.length-1]) > Math.abs(R-arrayR[0]) ? arrayR[0] : arrayR[arrayR.length-1]);
		G = (Math.abs(G-arrayG[arrayG.length-1]) > Math.abs(G-arrayG[0]) ? arrayG[0] : arrayG[arrayG.length-1]);
		B = (Math.abs(B-arrayB[arrayB.length-1]) > Math.abs(B-arrayB[0]) ? arrayB[0] : arrayB[arrayB.length-1]);

		AI.setRGB( x, y, R, G, B );				
	    }
	    this.switchThread();
	}
	this.switchThread();	//ύXʂɔf
	AI.repaintAll();
	return;	
    }

	
    //őlAŏlT߂̃\[g
    //֌WȂ̃\[g͍sȂ
    private void maxMinSort() {
	this.maxMinSort( arrayR );
	this.maxMinSort( arrayG );
	this.maxMinSort( arrayB );
	return;
    }
    private void maxMinSort(int array[])
    {
	for (int i=1; i<array.length; i++) {
	    if ( array[0] > array[i] ) {
		int temp = array[0];
		array[0] = array[i];
		array[i] = temp;
	    }
	}
	for (int i=array.length-2; i>=1; i--) {
	    if ( array[array.length-1] < array[i] ) {
		int temp = array[array.length-1];
		array[array.length-1] = array[i];
		array[i] = temp;
	    }
	}
	return;
    }
 class FilterMaxMinPanel extends FilterPanel implements AdjustmentListener{

	Label L1 = new Label("MaxMin parameter"),
	    L2 = new Label("Window Size");
     TextField T1 = new TextField(""+windowSize,5);
     Scrollbar S1 = new Scrollbar(Scrollbar.HORIZONTAL,windowSize,1,windowSizeMIN,windowSizeMAX);

	FilterMaxMinPanel(){
	    this.setLayout(new GridLayout(20,1));
	    this.add(new Container());
	    this.add(this.L1);
	    this.add(this.L2);
	    this.add(this.S1);
	    this.add(this.T1);
	    S1.addAdjustmentListener(this);
	}
	
	// tB^̃p[^擾ݒ肷
	public void setFilterParameter(){
	    try{
		windowSize = Integer.parseInt(T1.getText());
	    }catch(NumberFormatException e){}
	    if(windowSize > windowSizeMAX) windowSize = windowSizeMAX;
	    if(windowSize < windowSizeMIN) windowSize = windowSizeMIN;
	    T1.setText(""+windowSize);
	}

	public void adjustmentValueChanged(AdjustmentEvent e)
	{
	    int val;
	    Scrollbar se = (Scrollbar) e.getSource();
	    if(se == S1){
		val = S1.getValue();
		T1.setText(""+val);
	    }
	}  
    }
    
    // tB^p[^ݒ肷邽߂̃plԂ
    public FilterPanel getFilterPanel(){
	return new  FilterMaxMinPanel();
    }
}
