package imageFiltering.filter;

import imageFiltering.*;
import java.applet.*;
import java.awt.*;
import java.awt.event.*;
import java.io.*;

public class FilterMultiplexscale  extends Filter
{
    private int windowSize = 5,	//EBhETCY(ł邱)
	windowSizeMax = 35,
	windowSizeMin = 1;
    
    private double SIGMA =Math.pow(2.0,-3),	//ڂɉe
	SIGMAMax = 1000.0,
	SIGMAMin = 0.0001;
    
    private int I=16;
    private double SIGMA2[]=new double[I];	
    
    
    //L̓ύX΁AɏC̕Kv͂Ȃ
    
    
    
    private int offset = (windowSize-1) / 2;
    
    private double ND[][][] = new double[I][offset*2+1][offset*2+1];
    
    
	
	
	
	
    //ď݂vZ
    void weight(int n){
	int size = offset*2+1;
	double t[] = new double[size];

	    SIGMA2[n] = Math.sqrt(Math.pow(2.0,n-3));
	    final double k = 1.0 / Math.sqrt(2.0 * Math.PI) / SIGMA2[n];
	    //final  Đ錾ϐɂ͒lł܂ 
	    double total = 0.0;
	    for (int i=0; i<size; i++) {
		double x = i - offset;
		t[i] = k / Math.exp( x * x / (2 * SIGMA2[n] * SIGMA2[n]) );
		total += t[i];
	    }
	    for (int i=0; i<size; i++) t[i] /= total;
	    for (int i=0; i<size; i++) {
		for (int j=0; j<size; j++) {
		    ND[n][i][j] = t[i] * t[j];
		}
		
	    }
    }
    
    //̃tB^̖̂Ԃ
    public String getName()
    {
	int size = offset*2+1;
	return "Multiplexscale";
    }
	
    //摜̃tB^O
    public void filter(AnimatedImage AI)
    {

	
	double a1=Math.sqrt(Math.pow(2.0,11));
	double a2=Math.sqrt(Math.sqrt(Math.sqrt(Math.sqrt(2))));
	double total;
	double sumR[]=new double [I];
	double sumG[]=new double [I];
	double sumB[]=new double [I];
	 double w1[]=new double[I];
	 	double w2[] = new double[I];
	 double DR[]=new double[I];
	 double DG[]=new double[I];
	 double DB[]=new double[I];
	 int X=AI.getWidth();
	 int Y=AI.getHeight();
	 double SR0[][]=new double[X][Y];
	 double SG0[][]=new double[X][Y];
	 double SB0[][]=new double[X][Y];
	 double SR1[][]=new double[X][Y];
	 double SG1[][]=new double[X][Y];
	 double SB1[][]=new double[X][Y];
	 double SR2[][]=new double[X][Y];
	 double SG2[][]=new double[X][Y];
	 double SB2[][]=new double[X][Y];
	 double SR3[][]=new double[X][Y];
	 double SG3[][]=new double[X][Y];
	 double SB3[][]=new double[X][Y];
	 double SR4[][]=new double[X][Y];
	 double SG4[][]=new double[X][Y];
	 double SB4[][]=new double[X][Y];
	 
	 double FR1=0.0,FG1=0.0,FB1=0.0;
	 double FR2=0.0,FG2=0.0,FB2=0.0;
	 double b=1.0;
	 double b2 =0.5;
	 int L1; 
	 int L2;
	 double L3;
	 int FR3=160,FG3=160,FB3=160;
	 double FR4,FG4,FB4;
	 
	
	for (int y=0; y<AI.getHeight(); y++) {
	    for (int x=0; x<AI.getWidth(); x++) {
		for(int n=0;n<I;n++){
		total = sumR[n] = sumG[n] = sumB[n] = 0.0;
			DR[n]=DG[n]=DB[n]=0.0;
		}
	
 for(int n=0;n<I;n++){
 		
 		weight(n);
 	  total=0.0;
		if ( x-offset<0 || x+offset>=AI.getWidth() 
		     || y-offset<0 || y+offset>=AI.getHeight() ) {	//ʂ̒[̕
		   
		    for (int ix=-offset; ix<=offset; ix++) {
			for (int iy=-offset; iy<=offset; iy++) {
			    if ( x+ix<0 || x+ix>=AI.getWidth() || y+iy<0 || y+iy>=AI.getHeight() ) continue;
			    total += ND[n][ix+offset][iy+offset];
			    sumR[n] += AI.getR( x+ix, y+iy ) * ND[n][ix+offset][iy+offset];
			    sumG[n] += AI.getG( x+ix, y+iy ) * ND[n][ix+offset][iy+offset];
			    sumB[n] += AI.getB( x+ix, y+iy ) * ND[n][ix+offset][iy+offset];
			}
		    }
		    sumR[n] /= total;  sumG[n] /= total;  sumB[n] /= total;  
		}else {		//ʂ̒
		    for (int ix=-offset; ix<=offset; ix++) {
			for (int iy=-offset; iy<=offset; iy++) {
			    sumR[n] += AI.getR( x+ix, y+iy ) * ND[n][ix+offset][iy+offset];
			    sumG[n] += AI.getG( x+ix, y+iy ) * ND[n][ix+offset][iy+offset];
			    sumB[n] += AI.getB( x+ix, y+iy ) * ND[n][ix+offset][iy+offset];
			}
		    }
		}
 }
 
 //摜̍쐬
 for(int n=0;n<I;n++){
   		if(n<=2)
		w1[n]=0;
		else
      w1[n]=a1/Math.sqrt(Math.pow(2,(n+1)-3));
 }
for(int n=0;n<I-1;n++){
     DR[n]=sumR[n+1]-sumR[n];  
     DG[n]=sumG[n+1]-sumG[n];   
     DB[n]=sumB[n+1]-sumB[n];
     
 }
 //FR1=FG1=FB1=0;
 for(int n=0;n<I-1;n++){
 	FR1=FR1+DR[n]*w1[n];
 		FG1=FG1+DG[n]*w1[n];
 		FB1=FB1+DB[n]*w1[n];
 }
 	
    FR1=FR1+b+sumR[14];
	 FG1=FG1+b+sumG[14];
	 FB1=FB1+b+sumB[14];
	FR1=gethanni(FR1);
	FG1=gethanni(FG1);
	FB1=gethanni(FB1);
	SR0[x][y]=DR[0];SG0[x][y]=DG[0];SB0[x][y]=DB[0];
	SR1[x][y]=FR1;SG1[x][y]=FG1;SB1[x][y]=FB1;
	 L1 =getLuminance((int)FR1,(int)FG1,(int)FB1); //Px𓾂
	 AI.setRGB(x,y,(int)Math.rint(sumR[7]),(int)Math.rint(sumG[7]),(int)Math.rint(sumB[7]));//ڂ摜
//AI.setRGB(x,y, (int)Math.rint(sumR[0]), (int)Math.rint(sumG[0]), (int)Math.rint(sumB[0]));//шʉ߉摜
//	AI.setRGB( x, y, (int)Math.rint(FR1), (int)Math.rint(FG1), (int)Math.rint(FB1)); //摜
//e̓h̍쐬

	
	
		for(int n=0;n<I;n++)
		{
			if(n>=13)
				w2[n]=0;
				else 
					w2[n]=a2*Math.sqrt(Math.pow(2,(n+1)-3));
		}
//		FR2=FG2=FB2=0;
		for(int n=0;n<I-1;n++){
 	FR2=FR2+DR[n]*w2[n];
 		FG2=FG2+DG[n]*w2[n];
 		FB2=FB2+DB[n]*w2[n];
 }
			FR2=FR2+b2+sumR[14];
			FG2=FG2+b2+sumG[14];
			FB2=FB2+b2+sumB[14];
			FR2=gethanni(FR2);
	FG2=gethanni(FG2);
	FB2=gethanni(FB2);
	SR2[x][y]=FR2;SG2[x][y]=FG2;SB2[x][y]=FB2;
	 L2=getLuminance((int)FR2,(int)FG2,(int)FB2); //Px𓾂
	 L3=L1*L2/255;
	
		SR3[x][y]=L3;SG3[x][y]=L3;SB3[x][y]=L3;
			//AI.setRGB( x, y, (int)Math.rint(FR2), (int)Math.rint(FG2), (int)Math.rint(FB2));//Ae摜
//AI.setRGB(x,y,(int)L3,(int)L3,(int)L3);//Pڂ̌@F摜
			//rint :̒lɂƂ߂AvZ̐ɓ double lԂB
	  	
	   //ʂ̓h̉摜
	 
	   //AI.setRGB(x,y,FR3,FG3,FB3);//ǂ̓h摜
	  	
	  //F 
	   
	   	FR4=L3*FR3/255;FG4=L3*FG3/255;FB4=L3*FB3/255;
	SR4[x][y]=FR4;SG4[x][y]=FG4;SB4[x][y]=FB4;
	//	AI.setRGB(x,y,(int)Math.rint(FR4),(int)Math.rint(FG4),(int)Math.rint(FB4));	//Qڂ̌@F摜
/*	//FAe摜̍쐬(r)
	double FR5=0.0,FB5=0.0,FG5=0.0,hue,sat;
		int R5,G5,B5;	
		R5=AI.getR(x,y);G5=AI.getG(x,y);B5=AI.getB(x,y);
		hue=getHue(R5,G5,B5);
		sat=getSaturation(R5,G5,B5);
		int bri=getLuminance(R5,G5,B5);
	   HSBtoRGB(hue, sat,bri,FR5,FG5,FB5);
		
		double FR6,FB6,FG6;
			FR6=FR4*FR5/255;
			FG6=FG4*FG5/255;
			FB6=FB4*FB5/255;
		//	AI.setRGB(x,y,(int)Math.rint(FR6),(int)Math.rint(FG6),(int)Math.rint(FB6)); */
				
	       }
	   this.switchThread();
	}
	
	this.switchThread();	//ύXʂɔf
//	AI.repaintAll();

for (int y=0; y<AI.getHeight(); y++) {
	    for (int x=0; x<AI.getWidth(); x++) {
		AI.setRGB( x, y, (int)Math.rint(SR0[x][y]), (int)Math.rint(SG0[x][y]), (int)Math.rint(SB0[x][y]));
	    //шʉ߉摜
	    }
		this.switchThread();
	}
	this.switchThread();	//ύXʂɔf
	
	for (int y=0; y<AI.getHeight(); y++) {
	    for (int x=0; x<AI.getWidth(); x++) {
		AI.setRGB( x, y, (int)Math.rint(SR1[x][y]), (int)Math.rint(SG1[x][y]), (int)Math.rint(SB1[x][y]));
	    //摜
	    }
		this.switchThread();
	}
	this.switchThread();	//ύXʂɔf
	for (int y=0; y<AI.getHeight(); y++) {
	    for (int x=0; x<AI.getWidth(); x++) {
		AI.setRGB( x, y, (int)Math.rint(SR2[x][y]), (int)Math.rint(SG2[x][y]), (int)Math.rint(SB2[x][y]));
	    //Ae摜
	    }
		this.switchThread();
	}
	this.switchThread();	//ύXʂɔf
	for (int y=0; y<AI.getHeight(); y++) {
	    for (int x=0; x<AI.getWidth(); x++) {
		AI.setRGB( x, y, (int)Math.rint(SR3[x][y]), (int)Math.rint(SG3[x][y]), (int)Math.rint(SB3[x][y]));
	    //Pڂ̌@F摜
	    }
		this.switchThread();
	}
	this.switchThread();	//ύXʂɔf
	for (int y=0; y<AI.getHeight(); y++) {
	    for (int x=0; x<AI.getWidth(); x++) {
		AI.setRGB( x, y, (int)Math.rint(FR3), (int)Math.rint(FG3), (int)Math.rint(FB3));
	    //ʂ̓h̉摜
	    }
		this.switchThread();
	}
	this.switchThread();	//ύXʂɔf
	for (int y=0; y<AI.getHeight(); y++) {
	    for (int x=0; x<AI.getWidth(); x++) {
		AI.setRGB( x, y, (int)Math.rint(SR4[x][y]), (int)Math.rint(SG4[x][y]), (int)Math.rint(SB4[x][y]));
	    //2ڂ̌@F摜
	    }
		this.switchThread();
	}
	this.switchThread();	//ύXʂɔf
	AI.repaintAll();
	return;
	
    }
	public double gethanni(double a)
	{
		if(a<0) a=0;
		if(a>255)a=255;
		return a;
	}
   public double getHue(int r,int g,int b)//F𓾂
   {
   	int max=r,min=r;
	double hue;
	if(max<g)
		max=g;
	if(min>g)
		min=g;
	if(max<b)
		max=b;
	if(min>b);
		min=b;
		if (g == max) {
hue= (double)(b - r) / ( max - min ) * 60 + 120;
}	
else if (b == max) {
hue= (double)(r - g) / ( max - min ) * 60 + 240;
}
else if (g<b) {
hue= (double)(g - b) / ( max - min ) * 60 + 360;
}
else {
hue= (double)(g - b) / ( max - min ) * 60;
}
return hue;
}
public double getSaturation(int r,int g,int b) //ʓx𓾂
{
	int max=r,min=r;
	double saturation;
	if(max<g)
		max=g;
	if(min>g)
		min=g;
	if(max<b)
		max=b;
	if(min>b)
		min=b;
		saturation = (double)( max - min ) / max ;
	return saturation;
}
   public int getLuminance(int r, int g, int b) //Px𓾂
    {
	return (int)(0.3f*r + 0.59f*g + 0.11f*b);
    }
   public void HSBtoRGB(double hue, double sat, double bri, double r, double g, double b)
	{

		double phase, ofs, d1, d2, d3;
	
	// OĈƂ
	if(sat==0.0) {
		r = g = b = bri;
		return;
	}
	 phase = ( hue - Math.floor(hue) ) * 6.0;
	ofs = phase - Math.floor(phase);

	d1 = bri * ( 255 - sat );
	d2 = bri * ( 255- sat * ofs/360 );
	d3 = bri * ( 255 - sat * (255 - ofs)/360 );

	switch((int)phase) {
	case 0:
		r = bri;
		g = d3;
		b = d1;
		break;
	case 1:
		r = d2;
		g = bri;
		b = d1;
		break;
	case 2:
		r = d1;
		g = bri;
		b = d3;
		break;
	case 3:
		r = d1;
		g = d2;
		b = bri;
		break;
	case 4:
		r = d3;
		g = d1;
		b = bri;
		break;
	case 5:
		r = bri;
		g = d1;
		b = d2;
		break;
	}
}
	   
   
   
    /* vύX_ */
    /* ʏ̃tB^ɉĈȉ̓Ă */

   class FilterGaussianPanel extends FilterPanel implements AdjustmentListener{

	Label L1 = new Label("Gaussian parameter"),
	    L2 = new Label("sigma "),
	    L3 = new Label("Window Size");
	TextField T1 = new TextField(""+SIGMA,5),
	    T2 = new TextField(""+windowSize,5);
	Scrollbar S1 = new Scrollbar(Scrollbar.HORIZONTAL,100,1,0,1000),
	    S2 = new Scrollbar(Scrollbar.HORIZONTAL,(windowSize-1)/2,3,0,20);

	FilterGaussianPanel(){
	    this.setLayout(new GridLayout(20,1));
	    this.add(new Container());
	    this.add(this.L1);
	    this.add(this.L2);
	    this.add(this.S1);
	    this.add(this.T1);
	    this.add(this.L3);
	    this.add(this.S2);
	    this.add(this.T2);
	    S1.addAdjustmentListener(this);
	    S2.addAdjustmentListener(this);
	}
	
	// tB^̃p[^擾ݒ肷
	public void setFilterParameter(){
	    try{
		windowSize = Integer.parseInt(T2.getText());
	    }catch(NumberFormatException e){}
	    if(windowSize > windowSizeMax) windowSize = windowSizeMax;
	    if(windowSize < windowSizeMin) windowSize = windowSizeMin;
	    T2.setText(""+windowSize);
	    try{
		SIGMA = Double.parseDouble(T1.getText());
	    }catch(NumberFormatException e){}
	    if(SIGMA > SIGMAMax) SIGMA = SIGMAMax;
	    if(SIGMA < SIGMAMin) SIGMA = SIGMAMin;
	    T1.setText(""+SIGMA);
	    offset = (windowSize-1) / 2;
	    ND = new double[I][offset*2+1][offset*2+1];
	}

	public void adjustmentValueChanged(AdjustmentEvent e)
	{
	    int val;
	    Scrollbar se = (Scrollbar) e.getSource();
	    if(se == S1){
		val = S1.getValue();
		T1.setText(""+val/10.0);
	    }
	    else if(se == S2){
		val = S2.getValue();
		T2.setText(""+(val*2+1));
	    }
	}  
    }
    
    // tB^p[^ݒ肷邽߂̃plԂ
    public FilterPanel getFilterPanel(){
	return new  FilterGaussianPanel();
    }
}
