//fBA(l)tB^
// 2004 01.18 ƂŏC

package imageFiltering.filter;

import imageFiltering.*;
import java.awt.*;
import java.applet.*;
import java.awt.event.*;

public class FilterMedian extends Filter 
{
    int windowSize = 7;	//lTEBhETCY
    final int windowSizeMAX = 50;
    final int windowSizeMIN = 1;
    
	
    //EBhETCYύX΁AɏC̕Kv͂Ȃ
	
	
	
    int centerIndex = windowSize*windowSize / 2;	//̃CfbNX
    //e
    int arrayR[] = new int[windowSize*windowSize];
    int arrayG[] = new int[windowSize*windowSize];
    int arrayB[] = new int[windowSize*windowSize];
	
	
    //̃tB^̖̂Ԃ
    public String getName()
    {
	return "Median";
    }
	
    //摜̃tB^O
    public void filter(AnimatedImage AI)
    { 
	/* int centerIndex = windowSize*windowSize / 2;	//̃CfbNX
	//e
	int arrayR[] = new int[windowSize*windowSize];
	int arrayG[] = new int[windowSize*windowSize];
	int arrayB[] = new int[windowSize*windowSize]; */
	
	
	int preOffset = (windowSize-1) / 2;
	int afterOffset = windowSize - preOffset - 1;
	for (int y=0; y<AI.getHeight(); y++) {
	    for (int x=0; x<AI.getWidth(); x++) {
		int index = 0;
		if ( x-preOffset<0 || x+afterOffset>=AI.getWidth() 
		     || y-preOffset<0 || y+afterOffset>=AI.getHeight() ) {	//ʂ̒[̕
		    for (int ix=-preOffset; ix<=afterOffset; ix++) {
			for (int iy=-preOffset; iy<=afterOffset; iy++) {
			    if ( x+ix<0 || x+ix>=AI.getWidth() || y+iy<0 || y+iy>=AI.getHeight() ) {	
				arrayR[index] = AI.getR( x, y );
				arrayG[index] = AI.getG( x, y );
				arrayB[index] = AI.getB( x, y );
			    } else {
				arrayR[index] = AI.getR( x+ix, y+iy );
				arrayG[index] = AI.getG( x+ix, y+iy );
				arrayB[index] = AI.getB( x+ix, y+iy );
			    }
			    index++;
			}
		    }
		} else {		//ʂ̒
		    for (int ix=-preOffset; ix<=afterOffset; ix++) {
			for (int iy=-preOffset; iy<=afterOffset; iy++) {
			    arrayR[index] = AI.getR( x+ix, y+iy );
			    arrayG[index] = AI.getG( x+ix, y+iy );
			    arrayB[index] = AI.getB( x+ix, y+iy );
			    index++;
			}
		    }
		}
				//this.quickSort();
		this.medianSort();	//̕
		AI.setRGB( x, y, arrayR[centerIndex], arrayG[centerIndex], arrayB[centerIndex] );				
	    }
	    this.switchThread();
	}
	this.switchThread();	//ύXʂɔf
	AI.repaintAll();
	return;	
    }

	
    //ẽ\[g(NCbN\[g)
    private void quickSort()
    {
	this.quickSort( 0, arrayR.length-1, arrayR );
	this.quickSort( 0, arrayG.length-1, arrayG );
	this.quickSort( 0, arrayB.length-1, arrayB );
	return;
    }
    private void quickSort(int indexI, int indexJ, int array[])
    {
	if ( indexI >= indexJ ) return;
		
	int pivot = indexI;
	int i = indexI + 1;
	int j = indexJ;
		
	while ( i < j ) {
	    for ( ; i<=j; i++) {
		if ( array[pivot] <= array[i] ) break;
	    }
	    for ( ; i<=j; j--) {
		if ( array[pivot] > array[j] ) break;
	    }
	    if ( i < j ) {
		int temp = array[i];
		array[i] = array[j];
		array[j] = temp;
	    }
	}
	if ( pivot < j ) {
	    int temp = array[pivot];
	    array[pivot] = array[j];
	    array[j] = temp;
	    this.quickSort( indexI, j-1, array );
	}
	if ( i < indexJ ) {
	    this.quickSort( i, indexJ, array );
	}
	return;
    }

    //lT߂̃\[g
    //֌WȂ̃\[g͍sȂ
    private void medianSort() {
	this.medianSort( 0, arrayR.length-1, arrayR );
	this.medianSort( 0, arrayG.length-1, arrayG );
	this.medianSort( 0, arrayB.length-1, arrayB );
	return;
    }
    private void medianSort(int indexI, int indexJ, int array[])
    {
	if ( indexI >= indexJ ) return;
		
	int pivot = indexI;
	int i = indexI + 1;
	int j = indexJ;
		
	while ( i < j ) {
	    for ( ; i<=j; i++) {
		if ( array[pivot] <= array[i] ) break;
	    }
	    for ( ; i<=j; j--) {
		if ( array[pivot] > array[j] ) break;
	    }
	    if ( i < j ) {
		int temp = array[i];
		array[i] = array[j];
		array[j] = temp;
	    }
	}
	if ( pivot < j ) {
	    int temp = array[pivot];
	    array[pivot] = array[j];
	    array[j] = temp;
	    if ( indexI <= centerIndex && centerIndex <= j-1 ) this.medianSort( indexI, j-1, array );
	}
	if ( i < indexJ ) {
	    if ( i <= centerIndex && centerIndex <= indexJ ) this.medianSort( i, indexJ, array );
	}
	return;
    }

    class FilterMedianPanel extends FilterPanel implements AdjustmentListener{

	Label L1 = new Label("Median parameter"),
	    L2 = new Label("Window Size");
	TextField T1 = new TextField(""+windowSize,5);
	Scrollbar S1 = new Scrollbar(Scrollbar.HORIZONTAL,windowSize,1,windowSizeMIN,windowSizeMAX);

	FilterMedianPanel(){
	    this.setLayout(new GridLayout(20,1));
	    this.add(new Container());
	    this.add(this.L1);
	    this.add(this.L2);
	    this.add(this.S1);
	    this.add(this.T1);
	    S1.addAdjustmentListener(this);
	}
	
	// tB^̃p[^擾ݒ肷
	public void setFilterParameter(){
	    try{
		windowSize = Integer.parseInt(T1.getText());
	    }catch(NumberFormatException e){}
	    if(windowSize > windowSizeMAX) windowSize = windowSizeMAX;
	    if(windowSize < windowSizeMIN) windowSize = windowSizeMIN;
	    T1.setText(""+windowSize);
	}

	public void adjustmentValueChanged(AdjustmentEvent e)
	{
	    int val;
	    Scrollbar se = (Scrollbar) e.getSource();
	    if(se == S1){
		val = S1.getValue();
		T1.setText(""+val);
	    }
	}  
    }
    
    // tB^p[^ݒ肷邽߂̃plԂ
    public FilterPanel getFilterPanel(){
	return new  FilterMedianPanel();
    }
}
