

//ɹե륿
//ʥե륿Ȥ˲ɤ

/* 
   02TI034
    
*/

package imageFiltering.filter;

import imageFiltering.*;
import java.applet.*;
import java.awt.*;
import java.awt.event.*;

public class FilterTT extends Filter
{
    private int GaussianIf = 17,        //ե륿ͤȸβͤκɹ̡
	GaussianIfMax = 128,
	GaussianIfMin = 1;
    
    private int Snow = 85,              //ɹ
	SnowMax = 255,
	SnowMin = 20;
    
    private int windowSize = 31,	//ɥ(Ǥ뤳)
	windowSizeMax = 35,
	windowSizeMin = 1;
    
    private double SIGMA = 100.0,	//ܤ˱ƶ
	SIGMAMax = 1000.0,
	SIGMAMin = 0.0001;
	
    //嵭ĤѹС¾˽ɬפϤʤ
	
	
	
    private int offset = (windowSize-1) / 2;
    private double ND[][] = new double[offset*2+1][offset*2+1];
	
    //Ťߤη׻
    void weight(){
	int size = offset*2+1;
	double t[] = new double[size];
	final double k = 1.0 / Math.sqrt(2.0 * Math.PI) / SIGMA;
	double total = 0.0;
	for (int i=0; i<size; i++) {
	    double x = i - offset;
	    t[i] = k / Math.exp( x * x / (2 * SIGMA * SIGMA) );
	    total += t[i];
	}
	for (int i=0; i<size; i++) t[i] /= total;
	for (int i=0; i<size; i++) {
	    for (int j=0; j<size; j++) {
		ND[i][j] = t[i] * t[j];
	    }
	}
    }
	

    //Υե륿̾Τ֤
    public String getName()
    {
	int size = offset*2+1;
	return "ɹ";
    }
	
    //Υե륿
    public void filter(AnimatedImage AI)
    {
	weight();
	
	int tmp, tmpR, tmpG, tmpB;
	double total, sumR, sumG, sumB;
	for (int y=0; y<AI.getHeight(); y++) {
	    for (int x=0; x<AI.getWidth(); x++) {
		total = sumR = sumG = sumB = 0.0;
		if ( x-offset<0 || x+offset>=AI.getWidth() 
		     || y-offset<0 || y+offset>=AI.getHeight() ) {	//̤üʬ
		    for (int ix=-offset; ix<=offset; ix++) {
			for (int iy=-offset; iy<=offset; iy++) {
			    if ( x+ix<0 || x+ix>=AI.getWidth() || y+iy<0 || y+iy>=AI.getHeight() ) continue;
			    total += ND[ix+offset][iy+offset];
			    sumR += AI.getR( x+ix, y+iy ) * ND[ix+offset][iy+offset];
			    sumG += AI.getG( x+ix, y+iy ) * ND[ix+offset][iy+offset];
			    sumB += AI.getB( x+ix, y+iy ) * ND[ix+offset][iy+offset];
			}
		    }
		    sumR /= total;  sumG /= total;  sumB /= total;  
		} else {		//̤ʬ
		    for (int ix=-offset; ix<=offset; ix++) {
			for (int iy=-offset; iy<=offset; iy++) {
			    sumR += AI.getR( x+ix, y+iy ) * ND[ix+offset][iy+offset];
			    sumG += AI.getG( x+ix, y+iy ) * ND[ix+offset][iy+offset];
			    sumB += AI.getB( x+ix, y+iy ) * ND[ix+offset][iy+offset];
			}
		    }
		}
		tmp = (int)((((int)Math.rint(sumR) + (int)Math.rint(sumG) + (int)Math.rint(sumB))/3));//ե륿ʿ경ԥRGBʿ
	
		/*
		  ʿtmpȼºݤΥԥʿѤκ礭
		  ѥ᡼GaussianIf٤ơ
		  礭äʿ경Τˤɽ
		  ä鸵βɽ
		*/
				if(tmp*3 -(int)(
			      AI.getR((int)x,(int)y) 
			      + AI.getG((int)x,(int)y) 
			      + AI.getB((int)x,(int)y)
			      ) > GaussianIf ) 
		    {
			tmp+=Snow;
			if(tmp>255)tmp=255;
			if(tmp<0)tmp=0;
			AI.setRGB( x, y, 
				   tmp  ,  
				   tmp  , 
				   tmp   );
		    }
		else 	AI.setRGB( x, y, 
				   AI.getR((int)x,(int)y),  
				   AI.getG((int)x,(int)y), 
				   AI.getB((int)x,(int)y)   );
	    }
	    this.switchThread();
	}
	this.switchThread();	//ѹʬ̤ȿǤ
	AI.repaintAll();
	return;
    }


    /* ѹ */
    /* ̾Υե륿˲äưʲĤäƤ */

    class FilterTTPanel extends FilterPanel implements AdjustmentListener{

	Label L1 = new Label("Gaussian parameter"),
	    L2 = new Label("sigma "),
	    L3 = new Label("Window Size"),
	    L4 = new Label("ɹ(ͤۤ¿)"),
	    L5 = new Label("ɹ");
	
	TextField T1 = new TextField(""+SIGMA,5),
	    T2 = new TextField(""+windowSize,5),	
	    T3 = new TextField(""+GaussianIf,5),
	    T4 = new TextField(""+Snow,5);

	Scrollbar S1 = new Scrollbar(Scrollbar.HORIZONTAL,100,1,0,1000),
	    S2 = new Scrollbar(Scrollbar.HORIZONTAL,(windowSize-1)/2,3,0,20),
	    S3 = new Scrollbar(Scrollbar.HORIZONTAL,GaussianIf,1,0,128),
	    S4 = new Scrollbar(Scrollbar.HORIZONTAL,Snow,1,20,255);

	FilterTTPanel(){
	    this.setLayout(new GridLayout(20,1));
	    this.add(new Container());
	    this.add(this.L1);
	    this.add(this.L2);
	    this.add(this.S1);
	    this.add(this.T1);
	    this.add(this.L3);
	    this.add(this.S2);
	    this.add(this.T2);
	    
	    this.add(this.L4);
	    this.add(this.S3);
	    this.add(this.T3);

	    this.add(this.L5);
	    this.add(this.S4);
	    this.add(this.T4);

	    S1.addAdjustmentListener(this);
	    S2.addAdjustmentListener(this);
	    S3.addAdjustmentListener(this);
	    S4.addAdjustmentListener(this);
	}	
	// ե륿Υѥ᡼ꤹ
	public void setFilterParameter(){
	    try{
		windowSize = Integer.parseInt(T2.getText());
	    }catch(NumberFormatException e){}
	    if(windowSize > windowSizeMax) windowSize = windowSizeMax;
	    if(windowSize < windowSizeMin) windowSize = windowSizeMin;
	    T2.setText(""+windowSize);
	    try{
		SIGMA = Double.parseDouble(T1.getText());
	    }catch(NumberFormatException e){}
	    if(SIGMA > SIGMAMax) SIGMA = SIGMAMax;
	    if(SIGMA < SIGMAMin) SIGMA = SIGMAMin;
	    T1.setText(""+SIGMA);
	   
	    try{
		GaussianIf = Integer.parseInt(T3.getText());
	    }catch(NumberFormatException e){}
	    if(GaussianIf > GaussianIfMax) GaussianIf = GaussianIfMax;
	    if(GaussianIf < GaussianIfMin) GaussianIf = GaussianIfMin;
	    T3.setText(""+GaussianIf);
	      
	    try{
		Snow = Integer.parseInt(T4.getText());
	    }catch(NumberFormatException e){}
	    if(Snow > SnowMax) Snow = SnowMax;
	    if(Snow < SnowMin) Snow = SnowMin;
	    T4.setText(""+Snow);
	    
	    offset = (windowSize-1) / 2;
	    ND = new double[offset*2+1][offset*2+1];
	}

	public void adjustmentValueChanged(AdjustmentEvent e)
	{
	    int val;
	    Scrollbar se = (Scrollbar) e.getSource();
	    if(se == S1){
		val = S1.getValue();
		T1.setText(""+val/10.0);
	    }
	    else if(se == S2){
		val = S2.getValue();
		T2.setText(""+(val*2+1));
	    }
	    else if(se == S3){
		val = S3.getValue();
		T3.setText(""+(val));
	    } 
	    else if(se == S4){
		val = S4.getValue();
		T4.setText(""+(val));
	    }
	}  
    }
    
    // ե륿ѥ᡼ꤹ뤿Υѥ֤ͥ
    public FilterPanel getFilterPanel(){
	return new  FilterTTPanel();
    }
}
